VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ftpclass"
Attribute VB_Creatable = False
Attribute VB_Exposed = True
'Copyright (c) 1994 & 1995, Tony Lee & Associates, Inc.

#If Win32 Then
' declaration for session handle
Dim i_hndl As Long

#Else
' declaration for session handle
Dim i_hndl As Integer

#End If

Dim i_login As Boolean


Public Function login(ByVal host$, ByVal user$, ByVal pass$) As Boolean
If (i_hndl > 0) Then
    quit
End If

Screen.MousePointer = 11
i_hndl = ftp_login(host$, user$, pass$, "")
i_login = (i_hndl > 0)
login = i_login
Screen.MousePointer = 0
End Function

Private Sub Class_Initialize()
i_hndl = 0
i_login = False
End Sub


Public Sub quit()
If i_hndl > 0 Then
    ftp_quit i_hndl
End If
i_hndl = 0
i_login = False
End Sub

Private Sub Class_Terminate()
If i_hndl > 0 Then
    quit
End If
    
End Sub



Public Sub displaymsg()
Dim msg As String * 256

ftp_lasterror msg, 256

MsgBox Mid(msg, 1, InStr(1, msg, Chr(0)) - 1), _
    vbOKOnly, "FTP last message"

End Sub

Public Function lastmsg() As String
Dim msg As String * 256

ftp_lasterror msg, 256
lastmsg = Mid(msg, 1, InStr(1, msg, Chr(0)) - 1)

End Function

Public Function lastreply() As String
Dim msg As String * 256

ftp_copyreplystr i_hndl, msg, 256

lastreply = Mid(msg, 1, InStr(1, msg, Chr(0)) - 1)

End Function

Public Function dir(ByVal dirname As String) As String
Dim tmpFile As String * 144

Screen.MousePointer = 11
'get temp file
rc = f_gettempfname("ftp", tmpFile, 144)
rc = ftp_dir(i_hndl, dirname, tmpFile)
dir = ""
If rc = 0 Then
    ' process the file
    fileNo = FreeFile(0)
    Open tmpFile For Input Access Read As #fileNo
    InChr = Input(1, #fileNo)
    Do While Not EOF(fileNo)
        tmpString$ = tmpString$ + InChr
        InChr = Input(1, #fileNo)
    Loop
    Close #fileNo
    f_deletefile (tmpFile)
    dir = tmpString$
End If
Screen.MousePointer = 0
End Function

Public Function getfile(ByVal rfile As String, ByVal lfile As String) As Integer

Screen.MousePointer = 11
getfile = ftp_get(i_hndl, rfile, lfile)
Screen.MousePointer = 0

End Function

Public Function putfile(ByVal lfile As String, ByVal rfile As String) As Integer

Screen.MousePointer = 11
putfile = ftp_put(i_hndl, lfile, rfile)
Screen.MousePointer = 0

End Function

Public Function pwd() As String
Dim tmp As String * 256

Screen.MousePointer = 11
pwd = ""
If ftp_pwd(i_hndl, tmp, 256) = 0 Then
    pwd = Mid(tmp, 1, InStr(1, tmp, Chr(0)) - 1)
End If
Screen.MousePointer = 0

End Function

Public Function list(ByVal dirname As String) As String
Dim tmpFile As String * 144

Screen.MousePointer = 11
'get temp file
rc = f_gettempfname("ftp", tmpFile, 144)
rc = ftp_ls(i_hndl, dirname, tmpFile)
list = ""
If rc = 0 Then
    ' process the file
    fileNo = FreeFile(0)
    Open tmpFile For Input Access Read As #fileNo
    InChr = Input(1, #fileNo)
    Do While Not EOF(fileNo)
        tmpString$ = tmpString$ + InChr
        InChr = Input(1, #fileNo)
    Loop
    Close #fileNo
    f_deletefile (tmpFile)
    list = tmpString$
End If
Screen.MousePointer = 0

End Function


Public Sub abort()
Screen.MousePointer = 11
ftp_abort i_hndl
Screen.MousePointer = 0
End Sub

Public Function append(ByVal lfile As String, ByVal rfile As String) As Integer

Screen.MousePointer = 11
append = ftp_append(i_hndl, lfile, rfile)
Screen.MousePointer = 0
End Function

Public Function replystring() As String
Dim rc As Integer
Dim buffer As String * 256

Screen.MousePointer = 11
rc = ftp_copyreplystr(i_hnd, buffer, 256)
replystring = Mid(buffer, 1, InStr(buffer, Chr(0)) - 1)

End Function

Public Function delete(rfile As String) As Integer
Screen.MousePointer = 11
delete = ftp_delete(i_hndl, rfile)
Screen.MousePointer = 0
End Function




Public Function lcd()
MsgBox "Not implemented yet", vbOKOnly, "Test WINFTP (VB)"

End Function

Public Sub localunique()
ftp_localunique i_hndl
End Sub



Public Function mget(rfiles$) As Integer
Screen.MousePointer = 11
mget = ftp_mget(i_hndl, rfiles$)
Screen.MousePointer = 0
End Function

Public Function mkdir(rdir$) As Integer
Screen.MousePointer = 11
mkdir = ftp_mkdir(i_hndl, rdir$)
Screen.MousePointer = 0
End Function

Public Function mput(lfiles$) As Integer
Screen.MousePointer = 11
mput = ftp_mput(i_hndl, lfiles$, 0)
Screen.MousePointer = 0
End Function



Public Function quote(qstr$) As String
Dim rc As Integer
Dim buffer As String * 512
Screen.MousePointer = 11
quote = ""
If Len(qstr$) > 0 Then
    rc = ftp_quote(i_hndl, qstr$, buffer, 512)
    If (rc <> -1) Then
        quote = Mid(buffer, 1, InStr(1, buffer, Chr(0)) - 1)
    End If
Else
    MsgBox "Please type quote command in remote argument field", vbOKOnly, "FTP Quote"
End If
Screen.MousePointer = 0

End Function

Public Function rename(fromFile$, toFile$) As Integer

Screen.MousePointer = 11
rename = ftp_rename(i_hndl, fromFile$, toFile$)
Screen.MousePointer = 0

End Function

Public Function rmdir(rdir$) As Boolean

Screen.MousePointer = 11
rmdir = (ftp_rmdir(i_hndl, rdir$) = 0)
Screen.MousePointer = 0

End Function

Public Sub storeunique()
ftp_storeunique i_hndl
End Sub

Public Sub setascii()
ftp_setascii i_hndl
End Sub

Public Sub setbinary()
ftp_setbinary i_hndl
End Sub

Public Function ftpopen(ByVal host$) As Boolean
If (i_hndl > 0) Then
    quit
End If

Screen.MousePointer = 11
i_hndl = ftp_open(host$)
ftpopen = (i_hndl > 0)
Screen.MousePointer = 0
End Function



Public Function openport(host$, port As Integer) As Boolean
If (i_hndl > 0) Then
    quit
End If

Screen.MousePointer = 11
i_hndl = ftp_openport(host$, port)
openport = (i_hndl > 0)
Screen.MousePointer = 0
End Function

Public Function isconnect()
MsgBox "Not implemented yet", vbOKOnly, "Test WINFTP (VB)"
End Function

Public Sub noop()
ftp_noop i_hndl
End Sub

Public Function relogin(user$, passwd$) As Boolean

Screen.MousePointer = 11
If (ftp_relogin(i_hndl, user$, passwd$, "") = 0) Then
    i_login = True
Else
    i_login = False
End If

relogin = i_login
Screen.MousePointer = 0

End Function

Public Function gatelogin(ByVal host$, ByVal user$, ByVal pass$) As Integer

Screen.MousePointer = 11
If (i_login) Then
    gatelogin = ftp_gatelogin(i_hndl, host$, user$, pass$, "")
End If
Screen.MousePointer = 0

End Function



Public Function replycode() As Integer
replycode = ftp_replycode(i_hndl)
End Function

Public Function getfileattribute()

End Function

Public Function setfileattribute()
MsgBox "Not implemented yet", vbOKOnly, "Test WINFTP (VB)"

End Function

Public Function cd(rdir$) As Integer
Screen.MousePointer = 11
cd = ftp_cd(i_hndl, rdir$)
Screen.MousePointer = 0
End Function

Public Function statusBoxOn()
ftp_statusbox i_hndl, 1
End Function

Public Function statusBoxOff()
ftp_statusbox i_hndl, 0
End Function

