VERSION 4.00
Begin VB.Form w_attribute 
   Caption         =   "File Properties"
   ClientHeight    =   6030
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   6720
   Height          =   6435
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   6030
   ScaleWidth      =   6720
   Top             =   1170
   Width           =   6840
   Begin VB.CommandButton cb_close 
      Caption         =   "&Close"
      Height          =   495
      Left            =   3840
      TabIndex        =   11
      Top             =   5040
      Width           =   1335
   End
   Begin VB.CommandButton cb_set 
      Caption         =   "&Set"
      Height          =   495
      Left            =   1440
      TabIndex        =   10
      Top             =   5040
      Width           =   1335
   End
   Begin VB.CheckBox cbx_directory 
      Caption         =   "Directory"
      Height          =   375
      Left            =   3960
      TabIndex        =   9
      Top             =   4440
      Width           =   1215
   End
   Begin VB.CheckBox cbx_system 
      Caption         =   "System"
      Height          =   375
      Left            =   2400
      TabIndex        =   8
      Top             =   4440
      Width           =   1095
   End
   Begin VB.CheckBox cbx_rdonly 
      Caption         =   "ReadOnly"
      Height          =   375
      Left            =   960
      TabIndex        =   7
      Top             =   4440
      Width           =   975
   End
   Begin VB.CheckBox cbx_normal 
      Caption         =   "Normal"
      Height          =   375
      Left            =   3960
      TabIndex        =   6
      Top             =   3960
      Width           =   1215
   End
   Begin VB.CheckBox cbx_hidden 
      Caption         =   "Hidden"
      Height          =   375
      Left            =   2400
      TabIndex        =   5
      Top             =   3960
      Width           =   975
   End
   Begin VB.CheckBox cbx_arch 
      Caption         =   "Archive"
      Height          =   375
      Left            =   960
      TabIndex        =   4
      Top             =   3960
      Width           =   975
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   720
      TabIndex        =   3
      Top             =   480
      Width           =   5175
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   720
      TabIndex        =   2
      Top             =   3480
      Width           =   2415
   End
   Begin VB.FileListBox File1 
      Height          =   2760
      Left            =   3360
      TabIndex        =   1
      Top             =   1080
      Width           =   2535
   End
   Begin VB.DirListBox Dir1 
      Height          =   2280
      Left            =   720
      TabIndex        =   0
      Top             =   1080
      Width           =   2415
   End
End
Attribute VB_Name = "w_attribute"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

Private Sub cb_close_Click()
Unload Me
End Sub

Private Sub cb_set_Click()
Dim attr As Long
If cbx_normal.Value = 1 Then
    attr = f_fileattr_normal()
Else
    If (cbx_arch.Value = 1) Then
       attr = attr Or f_fileattr_arch()
    End If
    If (cbx_hidden.Value = 1) Then
       attr = attr Or f_fileattr_hidden()
    End If
    If (cbx_rdonly.Value = 1) Then
       attr = attr Or f_fileattr_rdonly()
    End If
    If (cbx_system.Value = 1) Then
       attr = attr Or f_fileattr_system()
    End If
    If (cbx_directory.Value = 1) Then
       attr = attr Or f_fileattr_subdir()
    End If
End If
f_setfileattr Text1.Text, attr
End Sub

Private Sub cbx_normal_Click()
If cbx_normal.Value = 1 Then
    cbx_arch.Value = 0
    cbx_hidden.Value = 0
    cbx_rdonly.Value = 0
    cbx_system.Value = 0
    cbx_directory.Value = 0
End If

End Sub

Private Sub Dir1_Change()
File1.Path = Dir1.Path
Text1.Text = Dir1.Path
End Sub


Private Sub Drive1_Change()
Dir1.Path = Drive1.Drive

End Sub


Private Sub File1_Click()
If Mid(File1.Path, Len(File1.Path), 1) = "\" Then
    Text1.Text = File1.Path + File1.filename
Else
    Text1.Text = File1.Path + "\" + File1.filename
End If
End Sub

Private Sub Text1_Change()
Dim attr As Long
Dim v As Long

attr = f_getfileattr(Text1.Text)
cbx_arch.Value = 0
cbx_hidden.Value = 0
cbx_rdonly.Value = 0
cbx_system.Value = 0
cbx_directory.Value = 0
cbx_normal.Value = 0
If attr = f_fileattr_normal() Then
    cbx_normal.Value = 1
Else
    v = f_fileattr_arch()
    If (attr And v) Then
        cbx_arch.Value = 1
    End If
    v = f_fileattr_hidden()
    If (attr And v) Then
        cbx_hidden.Value = 1
    End If
    v = f_fileattr_rdonly()
    If (attr And v) Then
        cbx_rdonly.Value = 1
    End If
    v = f_fileattr_system()
    If (attr And v) Then
        cbx_system.Value = 1
    End If
    v = f_fileattr_subdir()
    If (attr And v) Then
        cbx_directory.Value = 1
    End If
End If

End Sub


