Attribute VB_Name = "winftp32"
'WINFTP32.BAS  WINFTP32 Interface for Visual Basic v4.0 For Windows
'
'Copyright (c) 1994 - 1996, Tony Lee & Associates, Inc.

#If Win32 Then
' Declarations for 32 bits winftp
Declare Function ftp_abort Lib "winftp32.dll" Alias "ftp_abortA" (ByVal hndl As Long) As Long
Declare Function ftp_append Lib "winftp32.dll" Alias "ftp_appendA" (ByVal hndl As Long, ByVal localFile As String, ByVal remoteFile As String) As Long
Declare Function ftp_cd Lib "winftp32.dll" Alias "ftp_cdA" (ByVal hndl As Long, ByVal dirname As String) As Long
Declare Function ftp_cdup Lib "winftp32.dll" Alias "ftp_cdupA" (ByVal hndl As Long) As Long
Declare Function ftp_copyreplystr Lib "winftp32.dll" Alias "ftp_copyreplystrA" (ByVal hndl As Long, ByVal msg As String, ByVal msgSize As Long) As Long
Declare Function ftp_delete Lib "winftp32.dll" Alias "ftp_deleteA" (ByVal hndl As Long, ByVal remoteFile As String) As Long
Declare Function ftp_dir Lib "winftp32.dll" Alias "ftp_dirA" (ByVal hndl As Long, ByVal dirname As String, ByVal localFile As String) As Long
Declare Function ftp_get Lib "winftp32.dll" Alias "ftp_getA" (ByVal hndl As Long, ByVal remoteFile As String, ByVal localFile As String) As Long
Declare Function ftp_getreply Lib "winftp32.dll" Alias "ftp_getreplyA" (ByVal hndl As Long) As String
Declare Function ftp_lasterror Lib "winftp32.dll" Alias "ftp_lasterrorA" (ByVal msg As String, ByVal msglen As Long) As Long
Declare Function ftp_lcd Lib "winftp32.dll" Alias "ftp_lcdA" (ByVal localDir As String) As Long
Declare Function ftp_localunique Lib "winftp32.dll" Alias "ftp_localuniqueA" (ByVal hndl As Long) As Long
Declare Function ftp_login Lib "winftp32.dll" Alias "ftp_loginA" (ByVal serverName As String, ByVal userName As String, ByVal userPasswd As String, ByVal acct As String) As Long
Declare Function ftp_ls Lib "winftp32.dll" Alias "ftp_lsA" (ByVal hndl As Long, ByVal dirname As String, ByVal localFile As String) As Long
Declare Function ftp_mget Lib "winftp32.dll" Alias "ftp_mgetA" (ByVal hndl As Long, ByVal remoteFiles As String) As Long
Declare Function ftp_mkdir Lib "winftp32.dll" Alias "ftp_mkdirA" (ByVal hndl As Long, ByVal remoteDir As String) As Long
Declare Function ftp_mput Lib "winftp32.dll" Alias "ftp_mputA" (ByVal hndl As Long, ByVal localFiles As String, ByVal fileCase As Long) As Long
Declare Function ftp_put Lib "winftp32.dll" Alias "ftp_putA" (ByVal hndl As Long, ByVal localFile As String, ByVal remoteFile As String) As Long
Declare Function ftp_pwd Lib "winftp32.dll" Alias "ftp_pwdA" (ByVal hndl As Long, ByVal buffer As String, ByVal buflen As Long) As Long
Declare Function ftp_quote Lib "winftp32.dll" Alias "ftp_quoteA" (ByVal hndl As Long, ByVal quote As String, ByVal buffer As String, ByVal buflen As Long) As Long
Declare Function ftp_quit Lib "winftp32.dll" Alias "ftp_quitA" (ByVal hndl As Long) As Long
Declare Function ftp_rename Lib "winftp32.dll" Alias "ftp_renameA" (ByVal hndl As Long, ByVal fromFile As String, ByVal toFile As String) As Long
Declare Function ftp_rmdir Lib "winftp32.dll" Alias "ftp_rmdirA" (ByVal hndl As Long, ByVal remoteDir As String) As Long
Declare Function ftp_setascii Lib "winftp32.dll" Alias "ftp_setasciiA" (ByVal hndl As Long) As Long
Declare Function ftp_setbinary Lib "winftp32.dll" Alias "ftp_setbinaryA" (ByVal hndl As Long) As Long
Declare Function ftp_site Lib "winftp32.dll" Alias "ftp_siteA" (ByVal hndl As Long, ByVal remoteCmd As String) As Long
Declare Function ftp_storeunique Lib "winftp32.dll" Alias "ftp_storeuniqueA" (ByVal hndl As Long) As Long
Declare Function ftp_open Lib "winftp32.dll" Alias "ftp_openA" (ByVal host As String) As Long
Declare Function ftp_openport Lib "winftp32.dll" Alias "ftp_openportA" (ByVal host As String, ByVal port As Long) As Long
Declare Function ftp_isconnected Lib "winftp32.dll" Alias "ftp_isconnectedA" (ByVal hndl As Long) As Long
Declare Function ftp_noop Lib "winftp32.dll" Alias "ftp_noopA" (ByVal hndl As Long) As Long
Declare Function ftp_relogin Lib "winftp32.dll" Alias "ftp_reloginA" (ByVal hndl As Long, ByVal userName As String, ByVal userPasswd As String, ByVal acct As String) As Long
Declare Function ftp_gatelogin Lib "winftp32.dll" Alias "ftp_gateloginA" (ByVal hndl As Long, ByVal hostName As String, ByVal userName As String, ByVal userPasswd As String, ByVal acct As String) As Long
Declare Function ftp_statusbox Lib "winftp32.dll" Alias "ftp_statusboxA" (ByVal hndl As Long, ByVal flag As Long) As Long
Declare Function ftp_replycode Lib "winftp32.dll" Alias "ftp_replycodeA" (ByVal hndl As Long) As Long

Declare Function f_getfileattr Lib "winftp32.dll" Alias "f_getfileattrA" (ByVal pathname As String) As Long
Declare Function f_setfileattr Lib "winftp32.dll" Alias "f_setfileattrA" (ByVal pathname As String) As Long
Declare Function f_fileattr_arch Lib "winftp32.dll" Alias "f_fileattr_archA" () As Long
Declare Function f_fileattr_hidden Lib "winftp32.dll" Alias "f_fileattr_hiddenA" () As Long
Declare Function f_fileattr_normal Lib "winftp32.dll" Alias "f_fileattr_normalA" () As Long
Declare Function f_fileattr_rdonly Lib "winftp32.dll" Alias "f_fileattr_rdonlyA" () As Long
Declare Function f_fileattr_subdir Lib "winftp32.dll" Alias "f_fileattr_subdirA" () As Long
Declare Function f_fileattr_system Lib "winftp32.dll" Alias "f_fileattr_systemA" () As Long
Declare Function f_fileattr_compressed Lib "winftp32.dll" Alias "f_fileattr_compressedA" () As Long
Declare Function f_copyfile Lib "winftp32.dll" Alias "f_copyfileA" (ByVal src As String, ByVal dest As String) As Long
Declare Function f_rename Lib "winftp32.dll" Alias "f_renameA" (ByVal oldfile As String, ByVal newfile As String) As Long
Declare Function f_deletefile Lib "winftp32.dll" Alias "f_deletefileA" (ByVal filename As String) As Long
Declare Function f_mkdir Lib "winftp32.dll" Alias "f_mkdirA" (ByVal dirname As String) As Long
Declare Function f_rmdir Lib "winftp32.dll" Alias "f_rmdirA" (ByVal dirname As String) As Long
Declare Function f_getcwd Lib "winftp32.dll" Alias "f_getcwdA" (ByVal buffer As String, ByVal buflen As Long) As Long
Declare Function f_gettempfname Lib "winftp32.dll" Alias "f_gettempfnameA" (ByVal prefix As String, ByVal buffer As String, ByVal buflen As Long) As Long

#Else
' declaration for 16 bits winftp.dll
Declare Function ftp_abort Lib "winftp.dll" (ByVal hndl As Integer) As Integer
Declare Function ftp_append Lib "winftp.dll" (ByVal hndl As Integer, ByVal localFile As String, ByVal remoteFile As String) As Integer
Declare Function ftp_cd Lib "winftp.dll" (ByVal hndl As Integer, ByVal dirname As String) As Integer
Declare Function ftp_cdup Lib "winftp.dll" (ByVal hndl As Integer) As Integer
Declare Function ftp_copyreplystr Lib "winftp.dll" (ByVal hndl As Integer, ByVal msg As String, ByVal msgSize As Integer) As Integer
Declare Function ftp_delete Lib "winftp.dll" (ByVal hndl As Integer, ByVal remoteFile As String) As Integer
Declare Function ftp_dir Lib "winftp.dll" (ByVal hndl As Integer, ByVal dirname As String, ByVal localFile As String) As Integer
Declare Function ftp_get Lib "winftp.dll" (ByVal hndl As Integer, ByVal remoteFile As String, ByVal localFile As String) As Integer
Declare Function ftp_getreply Lib "winftp.dll" (ByVal hndl As Integer) As String
Declare Function ftp_lasterror Lib "winftp.dll" (ByVal msg As String, ByVal msglen As Integer) As Integer
Declare Function ftp_lcd Lib "winftp.dll" (ByVal localDir As String) As Integer
Declare Function ftp_localunique Lib "winftp.dll" (ByVal hndl As Integer) As Integer
Declare Function ftp_login Lib "winftp.dll" (ByVal serverName As String, ByVal userName As String, ByVal userPasswd As String, ByVal acct As String) As Integer
Declare Function ftp_ls Lib "winftp.dll" (ByVal hndl As Integer, ByVal dirname As String, ByVal localFile As String) As Integer
Declare Function ftp_mget Lib "winftp.dll" (ByVal hndl As Integer, ByVal remoteFiles As String) As Integer
Declare Function ftp_mkdir Lib "winftp.dll" (ByVal hndl As Integer, ByVal remoteDir As String) As Integer
Declare Function ftp_mput Lib "winftp.dll" (ByVal hndl As Integer, ByVal localFiles As String, ByVal fileCase As Integer) As Integer
Declare Function ftp_put Lib "winftp.dll" (ByVal hndl As Integer, ByVal localFile As String, ByVal remoteFile As String) As Integer
Declare Function ftp_pwd Lib "winftp.dll" (ByVal hndl As Integer, ByVal buffer As String, ByVal buflen As Integer) As Integer
Declare Function ftp_quote Lib "winftp.dll" (ByVal hndl As Integer, ByVal quote As String, ByVal buffer As String, ByVal buflen As Integer) As Integer
Declare Function ftp_quit Lib "winftp.dll" (ByVal hndl As Integer) As Integer
Declare Function ftp_rename Lib "winftp.dll" (ByVal hndl As Integer, ByVal fromFile As String, ByVal toFile As String) As Integer
Declare Function ftp_rmdir Lib "winftp.dll" (ByVal hndl As Integer, ByVal remoteDir As String) As Integer
Declare Function ftp_setascii Lib "winftp.dll" (ByVal hndl As Integer) As Integer
Declare Function ftp_setbinary Lib "winftp.dll" (ByVal hndl As Integer) As Integer
Declare Function ftp_site Lib "winftp.dll" (ByVal hndl As Integer, ByVal remoteCmd As String) As Integer
Declare Function ftp_storeunique Lib "winftp.dll" (ByVal hndl As Integer) As Integer
Declare Function ftp_open Lib "winftp.dll" (ByVal host As String) As Integer
Declare Function ftp_openport Lib "winftp.dll" (ByVal host As String, ByVal port As Integer) As Integer
Declare Function ftp_isconnected Lib "winftp.dll" (ByVal hndl As Integer) As Integer
Declare Function ftp_noop Lib "winftp.dll" (ByVal hndl As Integer) As Integer
Declare Function ftp_relogin Lib "winftp.dll" (ByVal hndl As Integer, ByVal userName As String, ByVal userPasswd As String, ByVal acct As String) As Integer
Declare Function ftp_gatelogin Lib "winftp.dll" (ByVal hndl As Integer, ByVal hostName As String, ByVal userName As String, ByVal userPasswd As String, ByVal acct As String) As Integer
Declare Function ftp_statusbox Lib "winftp.dll" (ByVal hndl As Integer, ByVal flag As Integer) As Integer
Declare Function ftp_replycode Lib "winftp.dll" (ByVal hndl As Integer) As Integer

Declare Function f_getfileattr Lib "winftp.dll" (ByVal pathname As String) As Long
Declare Function f_setfileattr Lib "winftp.dll" (ByVal pathname As String, ByVal attr As Long) As Long
Declare Function f_fileattr_arch Lib "winftp.dll" () As Long
Declare Function f_fileattr_hidden Lib "winftp.dll" () As Long
Declare Function f_fileattr_normal Lib "winftp.dll" () As Long
Declare Function f_fileattr_rdonly Lib "winftp.dll" () As Long
Declare Function f_fileattr_subdir Lib "winftp.dll" () As Long
Declare Function f_fileattr_system Lib "winftp.dll" () As Long
Declare Function f_fileattr_volid Lib "winftp.dll" () As Long
Declare Function f_copyfile Lib "winftp.dll" (ByVal src As String, ByVal dest As String) As Long
Declare Function f_rename Lib "winftp.dll" (ByVal oldfile As String, ByVal newfile As String) As Integer
Declare Function f_deletefile Lib "winftp.dll" (ByVal filename As String) As Integer
Declare Function f_mkdir Lib "winftp.dll" (ByVal dirname As String) As Integer
Declare Function f_rmdir Lib "winftp.dll" (ByVal dirname As String) As Integer
Declare Function f_getcwd Lib "winftp.dll" (ByVal buffer As String, ByVal buflen As Integer) As Integer
Declare Function f_gettempfname Lib "winftp.dll" (ByVal prefix As String, ByVal buffer As String, ByVal buflen As Integer) As Integer
#End If
